EnableExplicit
Global dymodll.l

Procedure.s IPF_GetLastError()
  Protected err,buffer,ferr,errormsg$
  err=GetLastError_()
  ferr=FormatMessage_(#FORMAT_MESSAGE_ALLOCATE_BUFFER|#FORMAT_MESSAGE_FROM_SYSTEM,0,err,GetUserDefaultLangID_(),@buffer,0,0)
  If buffer<>0
    errormsg$=PeekS(buffer)
    LocalFree_(buffer)
    errormsg$=RemoveString(errormsg$,Chr(13)+Chr(10))
    ProcedureReturn errormsg$
  EndIf
EndProcedure

Procedure IPF_SetLastError(ErrCode.l)
  SetLastError_(ErrCode)
EndProcedure

Procedure.s IPF_GetRegKey(Key.l, SubKey.s, ValueName.s="")
  Protected *Buffer, Buffersize.l=0, Type.l=0, Result$="", hKey
  
  If RegOpenKeyEx_(Key, @SubKey, 0, #KEY_ALL_ACCESS, @hKey) = #ERROR_SUCCESS
    If RegQueryValueEx_(hKey, @ValueName, 0, @Type, 0, @Buffersize) = #ERROR_SUCCESS
      If Buffersize
        *Buffer=AllocateMemory(Buffersize)
        If *Buffer
          If RegQueryValueEx_(hKey, @ValueName, 0, @Type, *Buffer, @Buffersize) = #ERROR_SUCCESS
            Select Type
              Case #REG_BINARY
                ;Debug "#REG_BINARY"
                Result$=""
              Case #REG_DWORD
                ;Debug "#REG_DWORD"
                Result$=StrU(PeekL(*Buffer),#PB_Long)
              Case #REG_DWORD_LITTLE_ENDIAN
                ;Debug "#REG_DWORD_LITTLE_ENDIAN"
                Result$=StrU(PeekL(*Buffer),#PB_Long)
              Case #REG_EXPAND_SZ
                ;Debug "#REG_EXPAND_SZ"
                Result$=PeekS(*Buffer)
              Case #REG_LINK
                ;Debug "#REG_LINK"
                Result$=PeekS(*Buffer,-1,#PB_Unicode)
              Case #REG_MULTI_SZ
                ;Debug "#REG_MULTI_SZ"
                Result$=PeekS(*Buffer)
              Case #REG_NONE
                ;Debug "#REG_NONE"
              Case #REG_QWORD
                ;Debug "#REG_QWORD"
                Result$=StrU(PeekL(*Buffer),#PB_Quad)
              Case #REG_QWORD_LITTLE_ENDIAN
                ;Debug "#REG_QWORD_LITTLE_ENDIAN"
                Result$=StrU(PeekL(*Buffer),#PB_Quad)
              Case #REG_SZ
                ;Debug "#REG_SZ"
                Result$=PeekS(*Buffer)
            EndSelect
          EndIf
        EndIf
      EndIf
    EndIf
  EndIf
  
  If *Buffer
    FreeMemory(*Buffer)
    *Buffer=0
  EndIf
  
  ProcedureReturn Result$
EndProcedure

Prototype.l Proto_ReadLabelFile(FileName.p-ascii) ; 1
Prototype.l Proto_WriteLabelFile(FileName.p-ascii) ; 1
Prototype.l Proto_WriteLabelFileEx(FileName.p-ascii,SaveAddress.l) ; 1
Prototype.l Proto_PrintLabel(DeviceName.p-ascii,Port.p-ascii,Quantity.l,bShowDialog.l) ; 1
Prototype.l Proto_PrintLabel2(DeviceName.p-ascii,*Dummy,Quantity.l,bShowDialog.l) ; 1
Prototype.l Proto_PrintLabelEx(DeviceName.p-ascii,Port.p-ascii,Quantity.l,bShowDialog.l,PaperTray.l) ; 1
Prototype.l Proto_PrintLabelEx2(DeviceName.p-ascii,*Dummy,Quantity.l,bShowDialog.l,PaperTray.l) ; 1
Prototype.l Proto_Output(hDC.l) ; 1
Prototype.l Proto_OutputXY(x.l,y.l,hDC.l) ; 1
Prototype   Proto_DrawLabel(hDC.l) ; 1
Prototype   Proto_SetZoom(Percent.l) ; 1
Prototype   Proto_SetShadow(State.l) ; 1
Prototype   Proto_GetLabelInfo(*LabelInfo.TLABELINFO) ; 1
Prototype.l Proto_GetLabelNames(*Buf,nBytes.l) ; 1
Prototype.l Proto_NewLabel(Name.p-ascii) ; 1
Prototype.l Proto_IsModified() ; 1
Prototype.l Proto_SetModified(State.l) ; 1
Prototype.l Proto_AddObject(ObjType.p-ascii,ObjName.p-ascii,*Size.RECT,Rotation.l,*Attrib) ; 1
Prototype.l Proto_EnumLabelObjects(*Buf,nBytes.l) ; 1
Prototype.l Proto_EnumVariableObjects(*Buf,nBytes.l) ; 1
Prototype.l Proto_WhichObject(x.l,y.l) ; 1
Prototype.l Proto_ObjectsAt(x.l,y.l,*Buf,nBytes.l) ; 1
Prototype.l Proto_ValidateBarCode(Text.p-ascii,BCType.l) ; 1
Prototype.l Proto_CopyToClipboard(*Buf.TObjectID) ; 1
Prototype.l Proto_PasteFromClipboard() ; 1
Prototype.l Proto_FindObject(Name.p-ascii) ; 1
Prototype.l Proto_DeleteLabelObject(ID.l) ; 1
Prototype.l Proto_BringObjectToFront(ID.l) ; 1
Prototype.l Proto_SendObjectToBack(ID.l) ; 1
Prototype.l Proto_SetAttributes(ID.l,*Attrib) ; 1
Prototype.l Proto_SetAttributesEx(ID.l,*Attrib) ; 1
Prototype.l Proto_GetAttributes(ID.l,*Attrib) ; 1
Prototype.l Proto_GetAttributesEx(ID.l,*Attrib) ; 1
Prototype.l Proto_GetInfo(*ObjectInfo.TOBJECTINFO) ; 1
Prototype.l Proto_SetInfo(*ObjectInfo.TOBJECTINFO) ; 1
Prototype.l Proto_GetLabelMargins(*pRect.RECT) ; 1
Prototype   Proto_SetPrinterModeState(State.l) ; 1
Prototype   Proto_SaveLastLabel() ; 1
Prototype   Proto_LoadLastLabel() ; 1
Prototype   Proto_SetLabelBackground(Color.l) ; 1
Prototype.l Proto_GetLabelOrientation(LabelName.p-ascii) ; 1
Prototype.l Proto_SetPrintDefaultMode(Mode.l) ; 1
Prototype.l Proto_GetDefaultStringMode() ; 1
Prototype.l Proto_CanUndo() ; 1
Prototype.l Proto_CanRedo() ; 1
Prototype   Proto_Undo() ; 1
Prototype   Proto_Redo() ; 1
Prototype   Proto_StartPrintJob() ; 1
Prototype   Proto_EndPrintJob() ; 1
Prototype.l Proto_ReadURLFile(sURL.p-ascii) ; 1
Prototype.l Proto_ReadStreamLabelFile(*Stream,Size.l) ; 1
Prototype.l Proto_WriteStreamLabelFile(*Stream,Size.l) ; 1
Prototype.l Proto_SuppressErrorMessage(bSuppress.l) ; 1

Global D_ReadLabelFile.i
Global D_WriteLabelFile.i
Global D_WriteLabelFileEx.i
Global D_PrintLabel.i
Global D_PrintLabel2.i
Global D_PrintLabelEx.i
Global D_PrintLabelEx2.i
Global D_Output.i
Global D_OutputXY.i
Global D_DrawLabel.i
Global D_SetZoom.i
Global D_SetShadow.i
Global D_GetLabelInfo.i
Global D_GetLabelNames.i
Global D_NewLabel.i
Global D_IsModified.i
Global D_SetModified.i
Global D_AddObject.i
Global D_EnumLabelObjects.i
Global D_EnumVariableObjects.i
Global D_WhichObject.i
Global D_ObjectsAt.i
Global D_ValidateBarCode.i
Global D_CopyToClipboard.i
Global D_PasteFromClipboard.i
Global D_FindObject.i
Global D_DeleteLabelObject.i
Global D_BringObjectToFront.i
Global D_SendObjectToBack.i
Global D_SetAttributes.i
Global D_SetAttributesEx.i
Global D_GetAttributes.i
Global D_GetAttributesEx.i
Global D_GetInfo.i
Global D_SetInfo.i
Global D_GetLabelMargins.i
Global D_SetPrinterModeState.i
Global D_SaveLastLabel.i
Global D_LoadLastLabel.i
Global D_SetLabelBackground.i
Global D_GetLabelOrientation.i
Global D_SetPrintDefaultMode.i
Global D_GetDefaultStringMode.i
Global D_CanUndo.i
Global D_CanRedo.i
Global D_Undo.i
Global D_Redo.i
Global D_StartPrintJob.i
Global D_EndPrintJob.i
Global D_ReadURLFile.i
Global D_ReadStreamLabelFile.i
Global D_WriteStreamLabelFile.i
Global D_SuppressErrorMessage.i

ProcedureDLL PureDYMO_Init()
  Protected value1$, value2$, dymopath$, dymodllname$, *MSGText.s
  
  dymodll=0
  value1$=IPF_GetRegKey(#HKEY_CLASSES_ROOT,".LWL","")
  If value1$
    value1$+"\shell\open\command"
    value2$=""
    value2$=IPF_GetRegKey(#HKEY_CLASSES_ROOT,value1$,"")
    If value2$<>""
      dymopath$=GetPathPart(value2$)
      dymodllname$=dymopath$+"labels.dll"
      If Len(dymodllname$)<>0
        dymodll=OpenLibrary(#PB_Any,dymodllname$)
      EndIf
    EndIf
  EndIf
  
  Global NewList DYMO_LabelNames.s()
  
  If dymodll
    D_ReadLabelFile.Proto_ReadLabelFile=GetFunction(dymodll,"ReadLabelFile")
    D_WriteLabelFile.Proto_WriteLabelFile=GetFunction(dymodll,"WriteLabelFile")
    D_WriteLabelFileEx.Proto_WriteLabelFileEx=GetFunction(dymodll,"WriteLabelFileEx") ; not in DLL
    D_PrintLabel.Proto_PrintLabel=GetFunction(dymodll,"PrintLabel")
    D_PrintLabel2.Proto_PrintLabel2=GetFunction(dymodll,"PrintLabel")
    D_PrintLabelEx.Proto_PrintLabelEx=GetFunction(dymodll,"PrintLabelEx")
    D_PrintLabelEx2.Proto_PrintLabelEx2=GetFunction(dymodll,"PrintLabelEx")
    D_Output.Proto_Output=GetFunction(dymodll,"Output")
    D_OutputXY.Proto_OutputXY=GetFunction(dymodll,"OutputXY")
    D_DrawLabel.Proto_DrawLabel=GetFunction(dymodll,"DrawLabel")
    D_SetZoom.Proto_SetZoom=GetFunction(dymodll,"SetZoom")
    D_SetShadow.Proto_SetShadow=GetFunction(dymodll,"SetShadow")
    D_GetLabelInfo.Proto_GetLabelInfo=GetFunction(dymodll,"GetLabelInfo")
    D_GetLabelNames.Proto_GetLabelNames=GetFunction(dymodll,"GetLabelNames")
    D_NewLabel.Proto_NewLabel=GetFunction(dymodll,"NewLabel")
    D_IsModified.Proto_IsModified=GetFunction(dymodll,"IsModified")
    D_SetModified.Proto_SetModified=GetFunction(dymodll,"SetModified")
    D_AddObject.Proto_AddObject=GetFunction(dymodll,"AddObject")
    D_EnumLabelObjects.Proto_EnumLabelObjects=GetFunction(dymodll,"EnumLabelObjects")
    D_EnumVariableObjects.Proto_EnumVariableObjects=GetFunction(dymodll,"EnumVariableObjects")
    D_WhichObject.Proto_WhichObject=GetFunction(dymodll,"WhichObject")
    D_ObjectsAt.Proto_ObjectsAt=GetFunction(dymodll,"ObjectsAt")
    D_ValidateBarCode.Proto_ValidateBarCode=GetFunction(dymodll,"ValidateBarCode")
    D_CopyToClipboard.Proto_CopyToClipboard=GetFunction(dymodll,"CopyToClipboard")
    D_PasteFromClipboard.Proto_PasteFromClipboard=GetFunction(dymodll,"PasteFromClipboard")
    D_FindObject.Proto_FindObject=GetFunction(dymodll,"FindObject")
    D_DeleteLabelObject.Proto_DeleteLabelObject=GetFunction(dymodll,"DeleteLabelObject")
    D_BringObjectToFront.Proto_BringObjectToFront=GetFunction(dymodll,"BringObjectToFront")
    D_SendObjectToBack.Proto_SendObjectToBack=GetFunction(dymodll,"SendObjectToBack")
    D_SetAttributes.Proto_SetAttributes=GetFunction(dymodll,"SetAttributes")
    D_SetAttributesEx.Proto_SetAttributesEx=GetFunction(dymodll,"SetAttributesEx")
    D_GetAttributes.Proto_GetAttributes=GetFunction(dymodll,"GetAttributes")
    D_GetAttributesEx.Proto_GetAttributesEx=GetFunction(dymodll,"GetAttributesEx")
    D_GetInfo.Proto_GetInfo=GetFunction(dymodll,"GetInfo")
    D_SetInfo.Proto_SetInfo=GetFunction(dymodll,"SetInfo")
    D_GetLabelMargins.Proto_GetLabelMargins=GetFunction(dymodll,"GetLabelMargins")
    D_SetPrinterModeState.Proto_SetPrinterModeState=GetFunction(dymodll,"SetPrinterModeState")
    D_SaveLastLabel.Proto_SaveLastLabel=GetFunction(dymodll,"SaveLastLabel")
    D_LoadLastLabel.Proto_LoadLastLabel=GetFunction(dymodll,"LoadLastLabel")
    D_SetLabelBackground.Proto_SetLabelBackground=GetFunction(dymodll,"SetLabelBackground")
    D_GetLabelOrientation.Proto_GetLabelOrientation=GetFunction(dymodll,"GetLabelOrientation") ; not in DLL
    D_SetPrintDefaultMode.Proto_SetPrintDefaultMode=GetFunction(dymodll,"SetPrintDefaultStringMode")
    D_GetDefaultStringMode.Proto_GetDefaultStringMode=GetFunction(dymodll,"GetPrintDefaultStringMode")
    D_CanUndo.Proto_CanUndo=GetFunction(dymodll,"CanUndo")
    D_CanRedo.Proto_CanRedo=GetFunction(dymodll,"CanRedo")
    D_Undo.Proto_Undo=GetFunction(dymodll,"Undo")
    D_Redo.Proto_Redo=GetFunction(dymodll,"Redo")
    D_StartPrintJob.Proto_StartPrintJob=GetFunction(dymodll,"StartPrintJob")
    D_EndPrintJob.Proto_EndPrintJob=GetFunction(dymodll,"EndPrintJob")
    D_ReadURLFile.Proto_ReadURLFile=GetFunction(dymodll,"ReadURLFile")
    D_ReadStreamLabelFile.Proto_ReadStreamLabelFile=GetFunction(dymodll,"ReadStreamLabelFile")
    D_WriteStreamLabelFile.Proto_WriteStreamLabelFile=GetFunction(dymodll,"WriteStreamLabelFile")
    D_SuppressErrorMessage.Proto_SuppressErrorMessage=GetFunction(dymodll,"SuppressErrorMessage")
  Else
    IPF_SetLastError(1157) ; ERROR_DLL_NOT_FOUND
    MessageRequester(*MSGText,IPF_GetLastError(),#MB_ICONWARNING) ; *MSGText=0 If this parameter is NULL, the default title Error is used.
  EndIf
EndProcedure

ProcedureDLL.s DYMO_GetAddressBookDirectory()
  Protected Dir$
  Dir$=IPF_GetRegKey(#HKEY_CURRENT_USER,"Software\DYMO\LabelWriter\Directories\","Address Book Directory")
  If Right(Dir$,1)<>"\"
    Dir$+"\"
  EndIf
  ProcedureReturn Dir$
EndProcedure

ProcedureDLL.s DYMO_GetClipartDirectory()
  Protected Dir$
  Dir$=IPF_GetRegKey(#HKEY_CURRENT_USER,"Software\DYMO\LabelWriter\Directories\","Clipart Directory")
  If Right(Dir$,1)<>"\"
    Dir$+"\"
  EndIf
  ProcedureReturn Dir$
EndProcedure

ProcedureDLL.s DYMO_GetLabelDirectory()
  Protected Dir$
  Dir$=IPF_GetRegKey(#HKEY_CURRENT_USER,"Software\DYMO\LabelWriter\Directories\","Label Directory")
  If Right(Dir$,1)<>"\"
    Dir$+"\"
  EndIf
  ProcedureReturn Dir$
EndProcedure

ProcedureDLL.l DYMO_ReadLabelFile(FileName.s)
  If D_ReadLabelFile
    ProcedureReturn D_ReadLabelFile(FileName)
  EndIf
EndProcedure

ProcedureDLL.l DYMO_WriteLabelFile(FileName.s)
  If D_WriteLabelFile
    ProcedureReturn D_WriteLabelFile(FileName)
  EndIf
EndProcedure

ProcedureDLL.l DYMO_WriteLabelFileEx(FileName.s,SaveAddress.l)
  If D_WriteLabelFileEx
    ProcedureReturn D_WriteLabelFileEx(FileName,SaveAddress)
  EndIf
EndProcedure

ProcedureDLL.l DYMO_PrintLabel(DeviceName.s,Port.s,Quantity.l,bShowDialog.l)
  If D_PrintLabel
    If Len(Port) ; PrintLabel exits when Port is an empty string (whole program ends !)
      ProcedureReturn D_PrintLabel(DeviceName,Port,Quantity,bShowDialog)
    Else
      ProcedureReturn D_PrintLabel2(DeviceName,0,Quantity,bShowDialog)
    EndIf
  EndIf
EndProcedure

ProcedureDLL.l DYMO_PrintLabelEx(DeviceName.s,Port.s,Quantity.l,bShowDialog.l,PaperTray.l)
  If D_PrintLabelEx
    If Port<>""
      ProcedureReturn D_PrintLabelEx(DeviceName,Port,Quantity,bShowDialog,PaperTray)
    Else
      ProcedureReturn D_PrintLabelEx2(DeviceName,0,Quantity,bShowDialog,PaperTray)
    EndIf
  EndIf
EndProcedure

ProcedureDLL.l DYMO_Output(hDC.l)
  If D_Output
    ProcedureReturn D_Output(hDC)
  EndIf
EndProcedure

ProcedureDLL.l DYMO_OutputXY(x.l,y.l,hDC.l)
  If D_OutputXY
    ProcedureReturn D_OutputXY(x,y,hDC)
  EndIf
EndProcedure

ProcedureDLL DYMO_DrawLabel(hDC.l)
  If D_DrawLabel
    D_DrawLabel(hDC)
  EndIf
EndProcedure

ProcedureDLL DYMO_SetZoom(Percent.l)
  If D_SetZoom
    D_SetZoom(Percent)
  EndIf
EndProcedure

ProcedureDLL DYMO_SetShadow(State.l)
  If D_SetShadow
    D_SetShadow(State)
  EndIf
EndProcedure

ProcedureDLL DYMO_GetLabelInfo(*LabelInfo.TLABELINFO)
  If D_GetLabelInfo
    D_GetLabelInfo(*LabelInfo)
  EndIf
EndProcedure

ProcedureDLL.l DYMO_GetLabelNames(*Buf,nBytes.l)
  If D_GetLabelNames
    ProcedureReturn D_GetLabelNames(*Buf,nBytes)
  EndIf
EndProcedure

ProcedureDLL.l DYMO_EnumLabelNames() ; Enumerates all labelnames (Returns number of labels found)
  Protected Buflen.l, *Buf, i.l
  
  ClearList(DYMO_LabelNames())
  
  Buflen=DYMO_GetLabelNames(0,0)
  If Buflen
    *Buf=AllocateMemory(Buflen)
    If *Buf And DYMO_GetLabelNames(*Buf,Buflen)
      For i=1 To Buflen/64
        AddElement(DYMO_LabelNames())
        DYMO_LabelNames()=PeekS(*Buf+(i-1)*64,-1,#PB_Ascii)
      Next
      FreeMemory(*Buf)
      *Buf=0
    EndIf
  EndIf
  
  If ListSize(DYMO_LabelNames())
    SortStructuredList(DYMO_LabelNames(),0,0,#PB_Sort_String)
  EndIf
  
  ProcedureReturn ListSize(DYMO_LabelNames())
EndProcedure

ProcedureDLL.s DYMO_GetLabelName(Index.l) ; Returns a labelname (Index starts at 0)
  Protected count
  
  count=ListSize(DYMO_LabelNames())
  If count>0 And (Index=<(count-1))
    SelectElement(DYMO_LabelNames(),Index)
    ProcedureReturn DYMO_LabelNames()
  EndIf
EndProcedure

ProcedureDLL.l DYMO_EnumLabelObjects(*Buf,nBytes.l)
  If D_EnumLabelObjects
    ProcedureReturn D_EnumLabelObjects(*Buf,nBytes)
  EndIf
EndProcedure

ProcedureDLL.l DYMO_GetAttributesEx(ID.l,*Attrib)
  If D_GetAttributesEx
    ProcedureReturn D_GetAttributesEx(ID,*Attrib)
  EndIf
EndProcedure

ProcedureDLL.l DYMO_SetAttributesEx(ID.l,*Attrib)
  If D_SetAttributesEx
    ProcedureReturn D_SetAttributesEx(ID,*Attrib)
  EndIf
EndProcedure

ProcedureDLL.l DYMO_GetLabelMargins(*pRect.RECT)
  If D_GetLabelMargins
    ProcedureReturn D_GetLabelMargins(*pRect)
  EndIf
EndProcedure

ProcedureDLL DYMO_StartPrintJob()
  If D_StartPrintJob
    D_StartPrintJob()
  EndIf
EndProcedure

ProcedureDLL.l DYMO_EndPrintJob()
  If D_EndPrintJob
    D_EndPrintJob()
  EndIf
EndProcedure

ProcedureDLL.l DYMO_NewLabel(Name.s)
  If D_NewLabel
    ProcedureReturn D_NewLabel(Name)
  EndIf
EndProcedure

ProcedureDLL.l DYMO_IsModified()
  If D_IsModified
    ProcedureReturn D_IsModified()
  EndIf
EndProcedure

ProcedureDLL.l DYMO_SetModified(State.l)
  If D_SetModified
    ProcedureReturn D_SetModified(State)
  EndIf
EndProcedure

ProcedureDLL.l DYMO_AddObject(ObjType.s,ObjName.s,*Size.RECT,Rotation.l,*Attrib)
  If D_AddObject
    ProcedureReturn D_AddObject(ObjType,ObjName,*Size,Rotation,*Attrib)
  EndIf
EndProcedure

ProcedureDLL.l DYMO_EnumVariableObjects(*Buf,nBytes.l)
  If D_EnumVariableObjects
    ProcedureReturn D_EnumVariableObjects(*Buf,nBytes)
  EndIf
EndProcedure

ProcedureDLL.l DYMO_WhichObject(x.l,y.l)
  If D_WhichObject
    ProcedureReturn D_WhichObject(x,y)
  EndIf
EndProcedure

ProcedureDLL.l DYMO_ObjectsAt(x.l,y.l,*Buf,nBytes.l)
  If D_ObjectsAt
    ProcedureReturn D_ObjectsAt(x,y,*Buf,nBytes)
  EndIf
EndProcedure

ProcedureDLL.l DYMO_ValidateBarCode(Text.s,BCType.l)
  If D_ValidateBarCode
    ProcedureReturn D_ValidateBarCode(Text,BCType)
  EndIf
EndProcedure

ProcedureDLL.l DYMO_CopyToClipboard(*Buf.TObjectID)
  If D_CopyToClipboard
    ProcedureReturn D_CopyToClipboard(*Buf)
  EndIf
EndProcedure

ProcedureDLL.l DYMO_PasteFromClipboard()
  If D_PasteFromClipboard
    ProcedureReturn D_PasteFromClipboard()
  EndIf
EndProcedure

ProcedureDLL.l DYMO_FindObject(Name.s)
  If D_FindObject
    ProcedureReturn D_FindObject(Name)
  EndIf
EndProcedure

ProcedureDLL.l DYMO_DeleteLabelObject(ID.l)
  If D_DeleteLabelObject
    ProcedureReturn D_DeleteLabelObject(ID)
  EndIf
EndProcedure

ProcedureDLL.l DYMO_BringObjectToFront(ID.l)
  If D_BringObjectToFront
    ProcedureReturn D_BringObjectToFront(ID)
  EndIf
EndProcedure

ProcedureDLL.l DYMO_SendObjectToBack(ID.l)
  If D_SendObjectToBack
    ProcedureReturn D_SendObjectToBack(ID)
  EndIf
EndProcedure

ProcedureDLL.l DYMO_SetAttributes(ID.l,*Attrib)
  If D_SetAttributes
    ProcedureReturn D_SetAttributes(ID,*Attrib)
  EndIf
EndProcedure

ProcedureDLL.l DYMO_GetAttributes(ID.l,*Attrib)
  If D_GetAttributes
    ProcedureReturn D_GetAttributes(ID,*Attrib)
  EndIf
EndProcedure

ProcedureDLL.l DYMO_GetInfo(*ObjectInfo.TOBJECTINFO)
  If D_GetInfo
    ProcedureReturn D_GetInfo(*ObjectInfo)
  EndIf
EndProcedure

ProcedureDLL.l DYMO_SetInfo(*ObjectInfo.TOBJECTINFO)
  If D_SetInfo
    ProcedureReturn D_SetInfo(*ObjectInfo)
  EndIf
EndProcedure

ProcedureDLL DYMO_SetPrinterModeState(State.l)
  If D_SetPrinterModeState
    D_SetPrinterModeState(State)
  EndIf
EndProcedure

ProcedureDLL DYMO_SaveLastLabel()
  If D_SaveLastLabel
    D_SaveLastLabel()
  EndIf
EndProcedure

ProcedureDLL DYMO_LoadLastLabel()
  If D_LoadLastLabel
    D_LoadLastLabel()
  EndIf
EndProcedure

ProcedureDLL DYMO_SetLabelBackground(Color.l)
  If D_SetLabelBackground
    D_SetLabelBackground(Color)
  EndIf
EndProcedure

ProcedureDLL.l DYMO_GetLabelOrientation(LabelName.s)
  If D_GetLabelOrientation
    ProcedureReturn D_GetLabelOrientation(LabelName)
  EndIf
EndProcedure

ProcedureDLL.l DYMO_SetPrintDefaultMode(Mode.l)
  If D_SetPrintDefaultMode
    ProcedureReturn D_SetPrintDefaultMode(Mode)
  EndIf
EndProcedure

ProcedureDLL.l DYMO_GetDefaultStringMode()
  If D_GetDefaultStringMode
    ProcedureReturn D_GetDefaultStringMode()
  EndIf
EndProcedure

ProcedureDLL.l DYMO_CanUndo()
  If D_CanUndo
    ProcedureReturn D_CanUndo()
  EndIf
EndProcedure

ProcedureDLL.l DYMO_CanRedo()
  If D_CanRedo()
    ProcedureReturn D_CanRedo()
  EndIf
EndProcedure

ProcedureDLL DYMO_Undo()
  If D_Undo
    D_Undo()
  EndIf
EndProcedure

ProcedureDLL.l DYMO_Redo()
  If D_Redo
    D_Redo()
  EndIf
EndProcedure

ProcedureDLL.l DYMO_ReadURLFile(sURL.s)
  If D_ReadURLFile
    ProcedureReturn D_ReadURLFile(sURL)
  EndIf
EndProcedure

ProcedureDLL.l DYMO_ReadStreamLabelFile(*Stream,Size.l)
  If D_ReadStreamLabelFile
    ProcedureReturn D_ReadStreamLabelFile(*Stream,Size)
  EndIf
EndProcedure

ProcedureDLL.l DYMO_WriteStreamLabelFile(*Stream,Size.l)
  If D_WriteStreamLabelFile
    ProcedureReturn D_WriteStreamLabelFile(*Stream,Size)
  EndIf
EndProcedure

ProcedureDLL.l DYMO_SuppressErrorMessage(bSuppress.l)
  If D_SuppressErrorMessage
    ProcedureReturn D_SuppressErrorMessage(bSuppress)
  EndIf
EndProcedure

ProcedureDLL PureDYMO_End()
  If dymodll And IsLibrary(dymodll)
    CloseLibrary(dymodll)
    dymodll=0
  EndIf
EndProcedure

; IDE Options = PureBasic 4.41 (Windows - x86)
; CursorPosition = 631
; FirstLine = 581
; Folding = -----------
; Executable = D:\PureDymo.exe